<?php
ob_start();
set_time_limit(0);
ignore_user_abort();
date_default_timezone_set('Asia/Shanghai');

define("DEBUG", 0);
if (DEBUG)
{
    require_once('logger.lib.php');
    if (!logger::log_opened())
        logger::log_open("itieba.log");
    logger::log_add_info('fetch');
}

if (!isset($uid))
{
    if (!isset($_GET['uid']))
        die('uid not set');
    else 
        $uid = $_GET['uid'];
}

if(DEBUG) FM_LOG_TRACE('uid: %s', $uid);

$rss_path  = "{$uid}.xml";
$itie_url  = "http://tieba.baidu.com/i/{$uid}/itie";
$itie_html = file_get_contents($itie_url);
$itie_utf8 = iconv("GBK", "UTF-8", $itie_html);

//获取i贴吧所有者
$matches = null;
$ret = preg_match_all('/PageData.itieba.creator.name_url\s*=\s*"([^"]*?)";/is', $itie_html, $matches);
if (!$ret) die('err matching author');
$author = trim($matches[1][0]);

//获取simple_block_container里的内容。内包含所有i帖
$pattern='/<div[^>]*?class="simple_block_container"[^>]*?>(\s|\n)*?<ul>(.*?)<\/ul>(\s|\n)*?<\/div>/is';
$matches = null;
$ret = preg_match($pattern, $itie_utf8, $matches);
if (!$ret) die('err matching simple_block_container');
$li_html = $matches[2];

//从simple_block_container中分离各个<li>（每一个i帖）
$pattern = '/<li>(.*?)<\/li>/is';
$ret = preg_match_all($pattern, $li_html, $matches);
if (!$ret) die('err matching &lt;li&gt;s');
$li_contents = $matches[1];

//获取i帖的地址和内容
$pattern = '/<a[^>]*?href="([^"]*?)".*?>([^<]*?)<\/a>/is';
$arr_itie = array();
$i = 0;
foreach ($li_contents as $li) 
{
    $ret = preg_match_all($pattern, $li, $matches);
    $arr_itie[$i] = array(
        'url'   => 'http://tieba.baidu.com' . $matches[1][0],
        'content' => $matches[2][0]
    );
    $i++;
}

if(DEBUG) FM_LOG_TRACE("arr_itie: ", print_r($arr_itie, true));

$cnt = count($arr_itie);

//获取每个i帖的具体内容(发布时间等信息)
for ($i = 0; $i < $cnt; $i++) {
    $itie_html = file_get_contents($arr_itie[$i]['url']);
    $pattern = '/PageData\.thread\s*=\s*({.*?});/';
    $matches = null;
    $ret = preg_match_all($pattern, $itie_html, $matches);
    $json_str = $matches[1][0];
    if(DEBUG) FM_LOG_TRACE("json_str[$i]: %s", $json_str);
    $json_arr = json_decode($json_str, true);
    $arr_itie[$i]['post_time'] = $json_arr['post_time'];
}

if(DEBUG) FM_LOG_TRACE("arr_itie: ", print_r($arr_itie, true));

//输出rss
echo <<<eot
<rss version="2.0"> 
<channel> 
<title><![CDATA[{$author}的i贴吧]]></title> 
<link>$itie_url</link> 
<language>zh-cn</language> 
<ttl>$cnt</ttl> 

eot;

$i = 0;
for ($i = 0; $i < $cnt && $i < 10; $i++) {
    $itie = $arr_itie[$i];
    if(DEBUG) FM_LOG_TRACE("itie[$i]: %s", print_r($itie, true));
    $content = htmlspecialchars($itie['content']);
    $time_str = date('r', strtotime($itie['post_time']));
    echo <<<eot
<item>
    <title><![CDATA[{$content}]]></title> 
    <link>{$itie['url']}</link> 
    <description> 
<![CDATA[ 
$content
]]>
    </description> 
    <pubDate>{$time_str}</pubDate> 
    <author>{$author}</author> 
    <guid>{$itie['url']}</guid> 
</item>

eot;
}

echo <<<eot
</channel> 
</rss>
eot;

$rss = ob_get_contents();

file_put_contents($rss_path, $rss);

?>
