<?php
define("DEBUG", 0);
if (DEBUG)
{
    require_once('logger.lib.php');
    logger::log_open("itieba.log");
}

$schema = 'http';
if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
    $schema = 'https';
}

if (!isset($_GET['uid']) && !isset($_GET['url']))
{
    die('uid not set');
}

$uid = '';
if (isset($_GET['uid']))
{
    $uid = $_GET['uid'];
}
else
{
    //$arr_url = parse_url($_GET['url']);
    $uid = preg_replace('=^.*/i/(\d+)/.*$=', '\1', $_GET['url']);
}

$rss_path = "$uid.xml";
header("Content-Type: text/xml; charset=utf-8");

if (!file_exists($rss_path))
{
    if(DEBUG) FM_LOG_TRACE('first time, generate');
    //first time, generate
    require_once('fetch.php');
    file_get_contents($url);
}
else
{
    $mtime = filemtime($rss_path);
    $now = time();
    if ($mtime > $now  //错误的mtime
        || $now - $mtime > 300)  //限制更新时间间隔, second
    {
        //update
        if(DEBUG) FM_LOG_TRACE('update');
        $ch = curl_init();

        $url = sprintf("%s://%s%s/fetch.php?uid=%s", $schema,
            $_SERVER['HTTP_HOST'], dirname($_SERVER['PHP_SELF']), $uid);
        if(DEBUG) FM_LOG_TRACE('url: %s', $url);

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        // grab URL and pass it to the browser
        $ret = curl_exec($ch);
        if(DEBUG) FM_LOG_TRACE('curl_ret: %s', $ret);
        if (curl_errno($ch))
        {
            if (DEBUG) FM_LOG_WARNING("curl err: [%d][%s]", curl_errno($ch), curl_error($ch));
        }

        // close cURL resource, and free up system resources
        curl_close($ch);
    }
}

if(DEBUG) FM_LOG_TRACE('start readfile');

readfile($rss_path);
?>
